import sys
import time

from PySide.QtCore import *
from Context.Provider import *
from Context.Subscriber import *

def newValue():
    print "NewValue!"

def newSubscriber(key):
    print "NewSubscriber!"

app = QCoreApplication(sys.argv)

timer = QTimer()
myService = Service(SessionBus, 'org.freedesktop.ContextKit.Commander')
myService.setAsDefault()
myProperty= Property('Screen.TopEdge')
myProperty.setValue('top')

def modifyProviderValue():
    print "ModifyProviderValue!"
    print mySubscriber.value()
    myProperty.setValue('bottom')
    app.exit(0)

myProperty.firstSubscriberAppeared.connect(newSubscriber)

mySubscriber = ContextProperty('Screen.TopEdge')
mySubscriber.valueChanged.connect(newValue)
mySubscriber.waitForSubscription()

timer.timeout.connect(modifyProviderValue)
timer.start(4)

app.exec_()
