import sys
import time

from PySide.QtCore import *
from Context.Provider import *

def handleNewValues():
    myScreen.setValue('top')
    time.sleep(0.25)
    print 'Last Screen value:', myScreen.value()

    myScreen.setValue('bottom')
    time.sleep(0.25)
    print 'Last Screen value:', myScreen.value()

    myScreen.setValue('left')
    time.sleep(0.25)
    print 'Last Screen value:', myScreen.value()

    myScreen.setValue('right')
    time.sleep(0.25)
    print 'Last Screen value:', myScreen.value()

    myEnvironment.setValue('True')
    time.sleep(0.25)
    print 'Last Environment value:', myEnvironment.value()
    myEnvironment.setValue(False)
    time.sleep(0.25)
    print 'Last Environment value:', myEnvironment.value()

    app.exit(0)

app = QCoreApplication(sys.argv)
timer = QTimer()
myService = Service(SessionBus, 'org.freedesktop.ContextKit.Commander')
myService.setAsDefault()
myScreen = Property('Screen.TopEdge')
myEnvironment = Property('Environment.IsDark')

timer.timeout.connect(handleNewValues)
timer.start(1750)

app.exec_()
